/*给用户主动调用的 您不需要改动 或者重写
* 只要 var api = new MagicalApi();
* 即可使用api.getHtml();等各种方法
* */
function MagicalApi() {

}
/*get*/
/**
 * 获取布局器HTML源码
 * @return string
 */
MagicalApi.prototype.getHtml=function () {}
/**
 * 获取布局器脚本
 * @return string
 */
MagicalApi.prototype.getJavascript=function () {}
/**
 * 获取布局器根节点json
 * @return JSON
 */
MagicalApi.prototype.getRootNode=function () {}
/**
 * @version 2.2.9
 * 获取样式
 */
MagicalApi.prototype.getCss = function(){}
/**
 * @version 2.2.9
 * 获取脚本设计器的数据
 */
MagicalApi.prototype.getMagicalJsCodeData = function(){}
/**
 * @version 2.2.9
 * 获取脚本设计器的根画布的样式
 * @return obj{}
 */
MagicalApi.prototype.getCanvasStyle = function(){}
/**
 * 能获取表单条目下的控件数据
 * @return JSON[]
 */
MagicalApi.prototype.getFormItemNodes = function (){}
/**
 * 获取constatn.js实例
 * 这样就可以灵活的根据事件情况来调整配置
 * @return JSON
 */
MagicalApi.prototype.getConstant = function () {}
/**
 * 获取iframe-ui.js实例
 * 这样就可以灵活的根据事件情况来调整配置
 * 打开iframe-ui.js 找到prototype.api=function(){} 您可以使用api.getIframeUi().api().各类操作脚本的方法
 * @return JSON
 */
MagicalApi.prototype.getIframeUi = function () {}
/**
 * @version 2.3.0
 * 搜索当前dom所属的node.magicalCoder.Id
 * @param elem 当前的dom结构 $DOM
 * @param firstSearchParent 首先往外层搜索 true|false  建议填写false可搜索绝大部分的场景
 * @return [] 大部分场景仅返回一个
 */
MagicalApi.prototype.getMagicalCoderIds = function (elem,firstSearchParent) {}
/**
 * @version 2.3.0
 * 根据id获取dom结构
 * @param magicalCoderId
 * @return {}
 */
MagicalApi.prototype.getElemByMagicalCoderId = function(magicalCoderId){}
/**
 * @version 2.3.0
 * 根据id获取node节点
 * @param magicalCoderId
 * @return {}
 */
MagicalApi.prototype.getNodeByMagicalCoderId = function (magicalCoderId) {}
/**
 * @version 2.3.0
 * 获取iframe的jquery对象 这样就可以自由获取内部结构了
 * @return 返回iframe内的$Dom
 * api.getIframeElemContents().find("input") 使用jquery查询方式即可
 */
MagicalApi.prototype.getIframeElemContents = function () {}
/**
 * 获取聚焦结构 默认返回第一个聚焦的原生
 * @return JSON[]
 */
MagicalApi.prototype.getFocusNode = function () {}
/**
 * 获取聚焦结构
 * @return JSON[]
 */
MagicalApi.prototype.findFocusNodes = function () {}
/**
 * 根据magicalCoderParam查询结构
 * @param fromNode 从哪个节点开始往下搜索 如果为null 则默认从根节点 JSON
 * @param magicalCoderParam 查询参数例如 查看node.magicalCoder属性即可得知参数 {id:1,....}  object
 * return []
 */
MagicalApi.prototype.searchNodes = function (fromNode,magicalCoderParam) {}
/**
 * 查找前置节点
 * @param magicalCoderId string
 * @return JSON
 */
MagicalApi.prototype.findPreNode = function (magicalCoderId) {}
/**
 * 查找后置节点
 * @param magicalCoderId string
 * @return JSON
 */
MagicalApi.prototype.findNextNode = function (magicalCoderId) {}
/**
 * 查找父亲节点
 * @param magicalCoderId string
 * @return JSON
 */
MagicalApi.prototype.findParentNode = function (magicalCoderId) {}

/**
 * 比如 "el-input":[{type:this.type.SELEC,attrName:'type',options:[{"text":"输入框","textarea":"文本框"}],"myId":"el-input-type",.....},]
 * @version 2.2.5
 * @param contentKey rightPanel下的content下的key 比如 'el-input'
 * @param queryObj 自定义一个查询 {"属性名":"属性值"} 这里的属性名可以由您自己定义一个 {"attrName":"type"}
 * 根据某个查询条件查询constant.js中配置的this.rightPanel下的一组满足条件的数据
 * 使用场景：如果您要根据ajax数据动态更改下拉框值 此方法很有用 记得改完调用api的refreshRightAttrPane()方法
 * @return []
 例如：以下代码更改form表单的label-position值 假设这段代码放after_start
 var list = api.getRightPanelItemListFromConstant("el-form",{attrName:"label-position"});
 console.log(list);
 for(var i=0;i<list.length;i++){
        list[i].options=[{"1":"新值"}]
    }
 */
MagicalApi.prototype.getRightPanelItemListFromConstant = function(contentKey,queryObj){}
/**
 * @version 2.2.7
 * 把rootNode平展开以key value形式返回
 * key:magicalCoder.id value:node
 * @param node 如果为null则默认去rootNode 根节点开始遍历
 *@return {}
 */
MagicalApi.prototype.getRootNodeMap=function(node){}
/*insert*/
/**
 * 插入源码到布局器
 * @param html  取值=""可以实现清空布局器 string
 */
MagicalApi.prototype.insertHtml=function (html) {}
/**
 * 插入javascript脚本 请尽量在insertHtml方法之后执行 因为大部分脚本操作的是html 必须先有html
 * @param javascript 不要="" 可以使用null来重置脚本 string
 */
MagicalApi.prototype.insertJavascript=function (javascript) {}
/**
 * @version 2.2.9
 * 插入css
 * @param css 取值=""可以实现清空样式 =null 则加载默认样式 string
 */
MagicalApi.prototype.insertCss=function (css) {}
/**
 * @version 2.2.9
 * 插入脚本设计器的数据
 * @param magicalJsCodeData 取值={}可以实现清空 =null 则加载默认样式 object
 */
MagicalApi.prototype.insertMagicalJsCodeData=function (magicalJsCodeData) {}
/**
 * @version 2.2.9
 * 插入脚本设计器的根画布样式
 * @param canvasStyle 取值={}可以实现清空 =null 则加载默认样式 object
 */
MagicalApi.prototype.insertCanvasStyle=function (canvasStyle) {}
/**
 * 插入html javascript css常用于初始化布局器
 * @param html        取值=""可以实现清空布局器  string
 * @param javascript  取值=null可以实现重置布局器的脚本 千万不要为"" 否则默认脚本不支持 工作区不渲染 string
 * @param css  取值=""可以实现清空样式 =null 则加载默认样式 string
 * @param magicalJsCodeData  脚本设计器的预置值，取值={}可以实现清空 =null 则加载默认 object
 * @param canvasStyle  body画布基本样式，取值={}可以实现清空 =null 则加载默认样式 object
 * api.insert(html,null,null,null,null)
 * api.insert(html,javascript,null,null,null)
 */
MagicalApi.prototype.insert=function (html,javascript,css,magicalJsCodeData,canvasStyle) {}
/**
 * 根据rootNode 还原布局器
 * @param rootNode  根据之前保存的json方式恢复布局器 javascript请配合insertJavascript实现 JSON
 * @param javascript  取值=null可以实现重置布局器的脚本 千万不要为"" 否则默认脚本不支持 工作区不渲染 string
 * @param css  取值=""可以实现清空样式 =null 则加载默认样式 string
 * @param magicalJsCodeData  脚本设计器的预置值，取值={}可以实现清空 =null 则加载默认 object
 * @param canvasStyle  body画布基本样式，取值={}可以实现清空 =null 则加载默认样式 object
 * api.insert(rootNode,null,null,null,null)
 * api.insert(rootNode,javascript,null,null,null)
 */
MagicalApi.prototype.insertNode=function (rootNode,javascript,css,magicalJsCodeData,canvasStyle) {}
/*update*/
/**
 * @version 2.2.9.2
 * 更改一组样式
 * @param node 被操作的节点                         json
 * @param styleObj {width:"100px",height:"100px"}  json
 * @param triggerChange 是否刷新界面   true|false
 * 不会触发样式回调事件
 */
MagicalApi.prototype.changeStyles = function (node, styleObj,triggerChange) {}
/**
 * @version 2.2.9.2
 * 改变样式
 * @param node 被操作的节点                         json
 * @param styleName 样式名 "height"                string
 * @param styleValue 样式值 "100px"                string
 * @param triggerChange true|false 是否触发刷新
 */
MagicalApi.prototype.changeStyle = function (node, styleName, styleValue,triggerChange){}
/**
 * @version 2.3.0
 * 改变文本
 * @param node 被操作的节点           json
 * @param text 内部文本               string
 * @param triggerChange true|false 是否触发刷新
 */
MagicalApi.prototype.changeText = function (node,text,triggerChange){}
/**
 * @version 2.3.0
 * 改变文本
 * @param node 被操作的节点           json
 * @param attrName  属性名             string
 * @param attrValue 属性值               string
 * @param triggerChange true|false 是否触发刷新
 */
MagicalApi.prototype.changeAttr = function (node,attrName,attrValue,triggerChange){}
/**
 * 重新设置孩子节点 比如您想在某个节点插入html 那么可以先把html调用htmlToRootNode得到node,
 * 然后childrenNodes = node.magicalCoder.children; 然后就可以调用此方法了 一般用在回调处理上
 * @param parentId 父节点magicalCoder.Id string
 * @param childrenNodes 子节点数组 JSON[]
 */
MagicalApi.prototype.resetChildren = function(parentId,childrenNodes){}
/**
 * 在节点中追加html
 * @param parentNode  JSON 父节点
 * @param html  string
 * @param preNode  JSON 在此节点后追加
 * @return true|false
 */
MagicalApi.prototype.appendHtml = function (parentNode,html,preNode) {}
/**
 * 重置节点内的html
 * @param parentNode  JSON 父节点
 * @param html  string
 * @return true|false
 */
MagicalApi.prototype.resetHtml = function (parentNode,html,triggerChange) {}
/**
 * 移动节点
 * @param dragMcId 要移动的id string
 * @param targetMcId 目标id string
 * @param moveType 可选值 inner prev next 类型 string
 */
MagicalApi.prototype.moveExistNode = function (dragMcId, targetMcId, moveType) {}
/*delete*/
/**
 * 删除多个节点
 * @param nodes JSON[] 主要是有magicalCoder.id
 */
MagicalApi.prototype.deleteNodes = function (nodes) {}
/**
 * @version 2.2.5
 * @param param 自定义一个参数 配合callback.js的reset_before(param)
 * 重置布局器
 */
MagicalApi.prototype.reset = function (param) {}
/*tool*/
/**
 * 聚焦某个结构
 * @param magicalCoderIds 结构的唯一magicalCoder.id string[]
 * @param forceFocus 强制刷新右侧属性面板 true|false
 */
MagicalApi.prototype.focus = function (magicalCoderIds,forceFocus) {}
/**
 * 把html转换成magicalCoderNode数据
 * @param html string
 */
MagicalApi.prototype.htmlToRootNode = function (html) {}
/**
 * 把magicalCoder node数据转换成html
 * @param nodes  可以通过rootNode.magicalCoder.children传入  JSON[]
 * @param htmlWithMagicalCoderAttr true|false 是否包含magicalcode属性 默认false  boolean
 */
MagicalApi.prototype.nodesToHtml = function (nodes,htmlWithMagicalCoderAttr) {}

/**
 * 主动触发布局器重绘工作区
 * @param force 是否强制刷新 默认false 强制刷新当您刷新不生效时可使用 比较耗费性能 会丢失当前聚焦结构 @2.2.9新增
 */
MagicalApi.prototype.refreshWorkspace = function (force) {}

/**
 * 仅仅把中间html重绘 并不触发节点变更
 */
MagicalApi.prototype.onlyCenterRefreshHtml = function(){}
/**
 * 重新构造左侧组件列表:如果您动态的向左侧增删组件 可以使用此方法
 * 您只需要修改完constant中的配置后 直接调用此方法 无需额外调用api.refresh();
 */
MagicalApi.prototype.rebuildLeftComponents = function () {}
/**
 * 刷新拖拽事件
 */
MagicalApi.prototype.refreshDragEvent = function () {}
/**
* 禁用拖拽事件
* @versin 2.3.0
*/
MagicalApi.prototype.disableDragEvent = function(){}
/**
* 启用拖拽事件
* @versin 2.3.0
*/
MagicalApi.prototype.enableDragEvent = function(){}
/**
 * 刷新右侧属性面板 如果您获取constant并且 动态修复属性配置，则需要调用此方法刷新事件
 * @param magicalCoderId string
 */
MagicalApi.prototype.refreshRightAttrPane = function (magicalCoderId) {}
/**
* @version 2.2.9
* 刷新整个布局器 简单粗暴
*/
MagicalApi.prototype.refreshAll = function(){}

